let fs = require("fs");
let UglifyJS = require("uglify-js");

let from = "./dist/"
let to = "./min";
let ret = fs.readdirSync(from)

ret.forEach(v => {
    if(/\.js$/.test(v)) {
        // 读取代码
        let code = fs.readFileSync(from + v).toString()
        code = code.replace(/['"]use strict['"];/ig, ""); // 去掉严格模式
        let com = /(\/\*\s*NAME:[\s\S]+<\/body><\/html>\s*\*\/)/.exec(code);
        let result = UglifyJS.minify(code, {
            mangle: {
                toplevel: true,
                reserved: ['_Return_Label_']
            }
        })
        if(com){
            result.code = com[1] + "\n" + result.code
        }
        if(!fs.existsSync(to)){
            fs.mkdirSync(to)
        }
        fs.writeFileSync(to+"/"+v, result.code.replace(/,_Return_Label_=/ig, ";return ") )
    }
})