"use strict";

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

/*
NAME: 
DESCRIPTION: 描述;
PARAMETER:
	[
		{
			name : 'step',
			title : 'step',
			type : 'LineEdit',
			property : {tool_tip : '目标step,默认是orig'}
		},
		{
			name : 'auto_save',
			title : '自动保存',
			type : 'RadioBox',
			property : {
				item_list:[
					{name:'yes',text:'YES'},
					{name:'no',text:'NO'},
				],
				tool_tip:'是否自动保存料号开关'
			}
		}
	]
	
 VERSION_HISTORY:
	V1.00 2021-03-08 Scott Sun
		1.新版本
		
 HELP:
	  <html><body bgcolor="#DDECFE">
		<font size="3" color="#003DB2"><p>功能简介</p></font>
		<p> 标题 </ p>
		<br>
		<font size="3" color="#003DB2"><p>参数配置</p></font>
		<p> step信息 </p>
		<br>
		<font size="3" color="#003DB2"><p>注意事项</p></font>
		<p> 无 </p>
		<br>
	</body></html>	
*/
// 引入模块 包 外部参数
var $ = require('topcam.scriptfunc').argv();

var fs = require("fs");

var _ = require('lodash');

var mode = $.ikm ? "topcam" : "aimdfm";

if (!$.ikm) {
  $.ikm = require('topcam.ikm6')($);
}

var IKM = $.ikm;
var GEN = $.gen;
var Job = $.job || $.job_name;
var JobId = $.job_id;
var db = $.db || IKM.db;
var GUI = $.gui;
var PAR = {};

if ($.par) {
  PAR = $.par;
} else if ($.hasOwnProperty('script_parameter')) {
  PAR = JSON.parse($.script_parameter);
}

if (mode === "aimdfm") {
  IKM.crud("updateRow", {
    table: "pdm_aimdfm_task",
    data: {
      current_process_title: $.process_title
    },
    where: {
      id: $.task_id
    }
  });
}

var Status = 'ok';
var resultData = [];
var par = PAR; // 接收参数

var default_par = {
  // 设置默认参数
  step: "orig",
  auto_save: "No",
  units: "mm"
};

for (var key in default_par) {
  if (!par.hasOwnProperty(key) || par[key] == "") {
    par[key] = default_par[key];
  }
} // 定义变量;


var job = Job.toLowerCase();

try {
  // 常规验证 准备工作
  if (!GEN.isJobExists({
    job: job
  })) {
    throw "料号" + job + "不存在";
  }

  if (!GEN.isJobOpen({
    job: job
  })) {
    GEN.openJob({
      job: job
    });
  }

  if (mode == "aimdfm") {
    if (GEN.checkInout({
      job: job,
      mode: "test"
    }) != 0) {
      throw "the job check";
    }

    GEN.checkInout({
      job: job,
      mode: "out"
    });
  }

  var obj = {
    name: "xiaobai"
  };

  var Person = /*#__PURE__*/function () {
    function Person(props) {
      _classCallCheck(this, Person);

      this.name = props.name;
      this.age = props.age;
      this.data = props.data;
    }

    _createClass(Person, [{
      key: "say",
      value: function say() {
        IKM.msg("my age is ".concat(this.age, ", my data is ").concat(_.toString(this.data)));
      }
    }]);

    return Person;
  }();

  var arr = [1, 2, [3, 4, 5]];
  var p = new Person(_objectSpread(_objectSpread({}, obj), {}, {
    age: 18,
    data: arr
  }));
  p.say();
  arr.flat(); // 保存料号

  if (/yes/ig.test(par.auto_save)) {
    GEN.checkInout({
      job: job,
      mode: "out"
    });
    GEN.saveJob({
      job: job
    });
    GEN.checkInout({
      job: job,
      mode: "in"
    });
  } // 结尾返回  固定写法


  var Return = "Done";

  if (mode === "aimdfm") {
    IKM.crud("updateRow", {
      table: "pdm_aimdfm_task",
      data: {
        progress: 100
      },
      where: {
        id: $.task_id
      }
    });
    var tmperr = {
      type: "info",
      title: "操作完成, 请注意检查!"
    };

    if (GEN.hasError()) {
      Status = 'error';
      tmperr = {
        type: "error",
        title: "GEN错误!",
        detail: [{
          desc: GEN.STATUS.join("\n")
        }]
      };
    }

    resultData.push(tmperr);
    Return = {
      status: status,
      result_data: resultData
    };
  }

  _Return_Label_ = Return;
} catch (e) {
  if (GEN.STATUS.length > 0) {
    IKM.msg(GEN.STATUS.join("\n"));
  }

  IKM.msg(e);
  Status = 'error';
  resultData.push({
    type: "error",
    title: "脚本执行出错!",
    detail: [{
      desc: _.toString(e)
    }]
  });
  _Return_Label_ = mode === "aimdfm" ? {
    status: Status,
    result_data: resultData
  } : "Error";
}
/**
 * 获取层别
 * @param {Object} 过滤选项
 * @returns {Array}
 */


function getLayer() {
  var props = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var matrix = GEN.getMatrix({
    job: job
  });
  return Object.keys(matrix).reduce(function (a, b) {
    var info = matrix[b];
    var ret = true;

    for (var _key in props) {
      if (info[_key]) {
        if (/object string|object number/ig.test({}.toString.call(props[_key]))) {
          if (props[_key] != info[_key]) {
            ret = false;
          }
        }

        if (/object RegExp/ig.test({}.toString.call(props[_key]))) {
          var reg = new RegExp(props[_key], "ig");

          if (!reg.test(info[_key])) {
            ret = false;
          }
        }

        if (/object function/ig.test({}.toString.call(props[_key]))) {
          if (!props[_key](info[_key])) {
            ret = false;
          }
        }
      }
    }

    if (ret) {
      a.push(props.res == "info" ? info : b);
    }

    return a;
  }, []);
}